"use strict";

function shield(fn, context) {
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    try {
      return fn.apply(context, args);
    } catch (err) {
      var callback = args.pop();
      callback(err);
    }
  };
}

module.exports = shield;